X-Git-Url: https://git.saurik.com/apt.git/blobdiff_plain/83b880c6505a20247239d897b7387bba37942993..c7872a2c857bc54febb09721f5256786a15c002d:/prepare-release

diff --git a/prepare-release b/prepare-release
index 7b7fd1224..734dc5f32 100755
--- a/prepare-release
+++ b/prepare-release
@@ -2,7 +2,6 @@
 set -e
 
 cd "$(readlink -f $(dirname $0))"
-dpkg-checkbuilddeps -d 'libxml2-utils'
 
 if [ -n "${GBP_BUILD_DIR}" ]; then
    cd "$GBP_BUILD_DIR"
@@ -16,13 +15,14 @@ LIBAPTINSTVERSION="$(egrep '^MAJOR=' apt-inst/makefile |cut -d '=' -f 2)"
 
 librarysymbolsfromfile() {
 	local MISSING="$(grep '^+#MISSING' "$1")"
+	local SYMVER="$2"
 	echo '=== Missing optional symbols:'
 	echo -n "$MISSING" | grep '|optional=' || true
 	echo '=== Missing required symbols:'
 	echo -n "$MISSING" | grep -v '|optional=' || true
 	echo '=== New symbols:'
 	grep '^+ ' "$1" | cut -d' ' -f 2 | cut -d'@' -f 1 | c++filt | while read line; do
-		echo " (c++)\"${line}@Base\" $VERSION"
+		echo " (c++)\"${line}@${SYMVER}\" $VERSION"
 	done | sort -u
 }
 
@@ -53,14 +53,14 @@ if [ "$1" = 'pre-export' ]; then
 		VERSION="$VERSION~$(date +%Y%m%d)"
 	fi
 
+	sed -i -e "s/^PACKAGE_VERSION=\".*\"$/PACKAGE_VERSION=\"${VERSION}\"/" configure.ac
+	sed -i -e "s/^<!ENTITY apt-product-version \".*\">$/<!ENTITY apt-product-version \"${VERSION}\">/" doc/apt-verbatim.ent
+
 	if [ "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' po/apt-all.pot | cut -d' ' -f 2)" -o \
 	     "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' doc/po/apt-doc.pot | cut -d' ' -f 2)" ]; then
 		echo >&2 'POT files are not up-to-date. Execute »make update-po« for you…'
 		make update-po
 	fi
-
-	sed -i -e "s/^PACKAGE_VERSION=\".*\"$/PACKAGE_VERSION=\"${VERSION}\"/" configure.ac
-	sed -i -e "s/^<!ENTITY apt-product-version \".*\">$/<!ENTITY apt-product-version \"${VERSION}\">/" doc/apt-verbatim.ent
 elif [ "$1" = 'post-build' ]; then
 	if [ "$DISTRIBUTION" != "UNRELEASED" ]; then
 		echo >&2 "REMEMBER: Tag this release with »git tag ${VERSION}« if you are satisfied"
@@ -68,6 +68,25 @@ elif [ "$1" = 'post-build' ]; then
 		echo >&2 'REMEMBER: Change to a valid distribution before release'
 	fi
 
+	dpkg-checkbuilddeps -d 'libxml2-utils'
+
+	HEADERBLUEPRINT="$(mktemp)"
+	sed -n '1,/^$/p' doc/apt.8.xml > "$HEADERBLUEPRINT"
+	find doc -mindepth 1 -maxdepth 1 -type f -name '*.xml' | while read FILE; do
+		if ! sed -n '1,/^$/p' "$FILE" | cmp "$HEADERBLUEPRINT" - >/dev/null 2>&1; then
+			echo >&2 "WARNING: Manpage $FILE has not the usual header! (see diff below)"
+			sed -n '1,/^$/p' "$FILE" | diff -u "$HEADERBLUEPRINT" - || true
+		fi
+	done
+	sed -n '1,/^$/p' doc/guide.dbk > "$HEADERBLUEPRINT"
+	find doc -mindepth 1 -maxdepth 1 -type f -name '*.dbk' | while read FILE; do
+		if ! sed -n '1,/^$/p' "$FILE" | cmp "$HEADERBLUEPRINT" - >/dev/null 2>&1; then
+			echo >&2 "WARNING: Documentation $FILE has not the usual header (see diff below)!"
+			sed -n '1,/^$/p' "$FILE" | diff -u "$HEADERBLUEPRINT" - || true
+		fi
+	done
+	rm "$HEADERBLUEPRINT"
+
 	# check the manpages with each vendor for vendor-specific errors…
 	find vendor -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 2 | while read DISTRO; do
 		ln -sf ../vendor/${DISTRO}/apt-vendor.ent doc
@@ -91,7 +110,7 @@ elif [ "$1" = 'library' ]; then
 		echo "Checking $1 in version $2"
 		local tmpfile=$(mktemp)
 		dpkg-gensymbols -p${1}${2} -ebuild/bin/${1}.so.${2} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile || true
-		librarysymbolsfromfile "$tmpfile"
+		librarysymbolsfromfile "$tmpfile" "$(echo "${1}" | cut -c 4- | tr -d '-' | tr 'a-z' 'A-Z')_${2}"
 		rm -f $tmpfile
 	}
 	librarysymbols 'libapt-pkg' "${LIBAPTPKGVERSION}"
@@ -99,19 +118,69 @@ elif [ "$1" = 'library' ]; then
 	librarysymbols 'libapt-inst' "${LIBAPTINSTVERSION}"
 elif [ "$1" = 'buildlog' ]; then
 	while [ -n "$2" ]; do
-		librarysymbolsfromfile "$2"
+		librarysymbolsfromfile "$2" 'UNKNOWN'
+		shift
+	done
+elif [ "$1" = 'travis-ci' ]; then
+	apt-get install -q --no-install-recommends $(sed -n -e '/^Build-Depends: /,/^Build-Depends-Indep: / {p}' debian/control | sed -e 's#([^)]*)##g' -e 's#^Build-Depends\(-Indep\)\?: ##' | tr -d ',')
+	apt-get install -q --no-install-recommends $(sed -n 's#^Depends: .*@, \(.*\)$#\1#p' debian/tests/control | tr -d ',')
+elif [ "$1" = 'coverage' ]; then
+	DIR="${2:-./coverage}"
+	git clean -dfX # remove ignored build artefacts for a clean start
+	make CFLAGS+='--coverage' CXXFLAGS+='--coverage'
+	LCOVRC='--rc geninfo_checksum=1 --rc lcov_branch_coverage=1'
+	mkdir "$DIR"
+	lcov --no-external --directory . --capture --initial --output-file "${DIR}/apt.coverage.init" ${LCOVRC}
+	make test || true
+	./test/integration/run-tests -q || true
+	lcov --no-external --directory . --capture --output-file "${DIR}/apt.coverage.run" ${LCOVRC}
+	lcov -a "${DIR}/apt.coverage.init" -a "${DIR}/apt.coverage.run"  -o "${DIR}/apt.coverage.total" ${LCOVRC}
+	cp "${DIR}/apt.coverage.total" "${DIR}/apt.coverage.fixed"
+	rewritefile() {
+		file="$1"
 		shift
+		name="$(basename "$file")"
+		while [ -n "$1" ]; do
+			if [ -r "$1/$name" ]; then
+				sed -i "s#$file#$1/$name#" "${DIR}/apt.coverage.fixed"
+				break
+			fi
+			shift
+		done
+		if [ -z "$1" ]; then
+			echo >&2 "Coverage data captured for unknown file $file"
+		fi
+	}
+	grep 'build/include/' "${DIR}/apt.coverage.fixed" | sed "s#^SF:$(pwd)/##" | while read file; do
+		rewritefile "$file" 'apt-pkg' 'apt-pkg/deb' 'apt-pkg/edsp' 'apt-pkg/contrib' \
+		   'apt-inst' 'apt-inst/deb' 'apt-inst/contrib' 'apt-private'
 	done
+	genhtml --output-directory "${DIR}" "${DIR}/apt.coverage.fixed" ${LCOVRC}
 else
 	echo >&1 "Usage:\t$0 pre-export
 \t$0 post-build
-\t$0 library
 
-If you use »git buildpackage« you can leave this script alone as it will
+If you use »git buildpackage« you can leave these alone as they will
 be run at the right places auto-magically. Otherwise you should use
 »pre-export« to update po and pot files as well as version numbering.
 »post-build« can be used to run some more or less useful checks later on.
 
-»library« isn't run automatically but can be useful for maintaining the
-(more or less experimental) symbols files we provide"
+\t$0 library
+\t$0 buildlog filename…
+
+»library« and »buildlog« aren't run automatically but can be useful for
+maintaining the (more or less experimental) symbols files we provide.
+»library« displays the diff between advertised symbols and the once provided
+by the libraries, while »buildlog« extracts this diff from the buildlogs.
+Both will format the diff properly.
+
+\t$0 travis-ci
+\t$0 coverage [output-dir]
+
+»travis-ci« is a shortcut to install all build- as well as test-dependencies
+used by .travis.yml.
+»coverage« does a clean build with the right flags for coverage reporting,
+runs all tests and generates a html report in the end.
+"
+
 fi